<?php declare (strict_types = 1);

namespace Infomaker\Everyware\NewsML\Parsers\Metadata;

use Infomaker\Everyware\NewsML\Parsers\Interfaces\ItemParser;
use Infomaker\Everyware\NewsML\Parsers\Interfaces\TypeParser;
use Infomaker\Everyware\NewsML\Item;
use SimpleXMLIterator;

class PolygonParser implements ItemParser, TypeParser
{
    public const OBJECT_TYPE = 'x-im/polygon';

    public function parse(SimpleXMLIterator $element): array
    {
        if (!property_exists($element, 'data') || empty($element->data)) {
            return [];
        }

        $item = new Item($element);
        $values = $element->data->children();
        $data = [];

        foreach ($values as $tag => $value) {
            $data[$tag] = (string) $value;
        }
        $item->fill($data);

        return [$item];
    }

    public function typeToParse(): string
    {
        return static::OBJECT_TYPE;
    }
}
