<?php

namespace Spec\Infomaker\Everyware\NewsML\Parsers;

use Infomaker\Everyware\NewsML\Parsers\TableParser;
use Infomaker\Everyware\NewsML\Item;
use PhpSpec\ObjectBehavior;
use Prophecy\Argument;

class TableParserSpec extends ObjectBehavior
{
    function it_is_initializable()
    {
        $this->shouldHaveType(TableParser::class);
    }
    public function it_should_parse_an_element_with_data()
    {
        $xml = '
            <object type="x-im/table">
                <data>
                    <tbody><tr>headet</tr></tbody>
                </data>
            </object>';
        $el = simplexml_load_string($xml, 'SimpleXMLIterator');
        $this->parse($el)
            ->shouldHaveArrayValue('<tbody><tr>headet</tr></tbody>');
    }
    public function it_should_parse_an_element_without_data()
    {
        $xml = '
            <object>
            </object>';
        $el = simplexml_load_string($xml, 'SimpleXMLIterator');
        $this->parse($el)
            ->shouldHaveArrayValue('');
    }
    public function it_should_return_its_type()
    {
        $this->typeToParse()->shouldReturn('x-im/table');
    }
    public function getMatchers(): array
    {
        return [
            'haveArrayValue' => function ($subject, $value) {
                return ($subject[0]->getItemAttribute('body') === $value) && ($subject[0] instanceof Item);
            },
        ];
    }
}
